program Msg_area_editor;

uses msgunit,userunit,crt,dos;

{$r+,i+,s+}

TYPE
      confer = array[1..20] of conf_cfg2;
      base = array[1..50] of base_rec2;

VAR
    cnf_nr   : worD;
    cnf_cfg2 : ^confer;

    base_nr  : word;
    base_cfg : ^base;

    cnf_file : file;
    areafile : file;
    msg_file : file;


function checkpath(s:string):boolean;
var dirinfo:searchrec;
begin
  findfirst(cnf_cfg2^[1].dir,$10,dirinfo);
  if doserror=0 then checkpath:=true else checkpath:=false;
end;


procedure init;
begin
  cnf_nr := 0;
  new(cnf_cfg2);
  new(base_cfg);

  new(usr_read); new(usr_write);
  new(txt);

  assign(cnf_file, 'Conf.cfg');
end;


procedure light(x1,y1,len:byte);
var a:byte;
begin
  for a:=x1 to x1+len-1 do mem[$b800:y1*160+a*2+1]:=31;
end;

procedure unlight(x1,y1,len:byte);
var a:byte;
begin
  for a:=x1 to x1+len-1 do mem[$b800:y1*160+a*2+1]:=7;
end;


procedure c_edit(nr:byte);
var a:byte;
    k:char;
const poy:array[1..5] of byte = (1,2,5,6,7);
      pox:array[1..5] of byte = (6,1,11,3,6);
      pol:array[1..5] of byte = (5,10,4,12,9);

procedure visa1;
begin
  i_pipe(pox[1]+1+pol[1],4,cnf_cfg2^[nr].name,true);
  i_pipe(pox[2]+1+pol[2],5,cnf_cfg2^[nr].dir,true);
  i_pipe(pox[3]+1+pol[3],8,cnf_cfg2^[nr].access.age,true);
  i_pipe(pox[4]+1+pol[4],9,cnf_cfg2^[nr].access.lev,true);
  i_pipe(pox[5]+1+pol[5],10,cnf_cfg2^[nr].access.psw,true);
end;

begin
  for a:=4 to 19 do kalle(a,0,79);

  a:=1;
  i_pipe(1,4,'     Name:',true);
  i_pipe(1,5,'Directory:',true);
  i_pipe(1,7,' |30S|b0p|f0ecial things needed to get acce|b0s|30s|80:',true);
  i_pipe(1,8,'          Age:',false);
  i_pipe(1,9,'  Statuslevel:',false);
  i_pipe(1,10,'     Password:',false);

  light(pox[a],poy[a]+3,pol[a]);

  visa1;

  repeat
    k:=readkey;
    if k=#0 then begin
      k:=readkey;
      case k of
        #72: begin
               unlight(pox[a],poy[a]+3,pol[a]);
               if a>1 then dec(a) else a:=5;
               light(pox[a],poy[a]+3,pol[a]);
             end;
        #80: begin
               unlight(pox[a],poy[a]+3,pol[a]);
               if a<5 then inc(a) else a:=1;
               light(pox[A],poy[a]+3,pol[a]);
             end;
        #83: begin
              case a of
                1: cnf_cfg2^[nr].name       := '';
                2: cnf_cfg2^[nr].dir        := '';
                3: cnf_cfg2^[nr].access.age := '';
                4: cnf_cfg2^[nr].access.lev := '';
                5: cnf_cfg2^[nr].access.psw := '';
              end;
              visa1;
             end;
      end;
    end else case k of
       #13: begin
              case a of
                1: cnf_cfg2^[nr].name       := i_readln(cnf_cfg2^[nr].name,4,pox[1]+1+pol[1],40);
                2: cnf_cfg2^[nr].dir        := i_readln(cnf_cfg2^[nr].dir,5,pox[2]+1+pol[2],30);
                3: cnf_cfg2^[nr].access.age := i_readln(cnf_cfg2^[nr].access.age,8,pox[3]+1+pol[3],3);
                4: cnf_cfg2^[nr].access.lev := i_readln(cnf_cfg2^[nr].access.lev,9,pox[4]+1+pol[4],5);
                5: cnf_cfg2^[nr].access.psw := i_readln(cnf_cfg2^[nr].access.psw,10,pox[5]+1+pol[5],20);
              end;

              cnf_cfg2^[nr].dir:=upc(cnf_cfg2^[nr].dir);
              visa1;
            end;
    end;
  until k=#27;

  for a:=4 to 19 do kalle(a,0,79);
end;

procedure make_conf(y:byte);
var a:word;
begin
  cnf_cfg2^[y].name:='';
  cnf_cfg2^[y].dir:='';
  cnf_cfg2^[y].access.age:='';
  cnf_cfg2^[y].access.lev:='';
  cnf_cfg2^[y].access.psw:='';
  c_Edit(y);
end;

VAR
    c_posy : byte;
    c_tot  : byte;

procedure c_load;
var fil : file of conf_cfg2;
      a : byte;
begin
 assign(fil,'conf.fny');
 if exists('conf.fny') then begin
    reset(fil);
    for a:=1 to filesize(fil) do read(fil,cnf_cfg2^[a]);
    c_tot:=filesize(fil);
    C_posy:=1;

 end;
end;

procedure c_save; { save the conferances }
var fil : file of conf_cfg2;
      a : byte;
begin
 assign(fil, 'conf.fny');
 if exists('conf.fny') then reset(fil) else rewrite(fil);
 for a:=1 to c_tot do write(fil,cnf_cfg2^[a]);
 close(fil);
end;

procedure visa2;
var a:byte;
begin
  for a:=1 to c_tot do i_pipe(2,3+a,cnf_cfg2^[a].name,true);
  if c_tot>0 then light(2,C_posy+3,length(cnf_cfg2^[c_posy].name));
end;

procedure main;
var k : char;
    a      : byte;

begin
  textmode(co80); cursor_off;
  i_pipe(0,0,'|f1                    fELONY BBS Software v1.0 - Conferance Editor                ',false);
  i_pipe(0,21,'    INS - Insert a new conferance          ENTER - Edit conferance',true);
  i_pipe(0,22,'                           ESC - Exit and save                    ',true);
  i_pipe(0,3,st_line,false);  i_pipe(0,20,st_line,false);

  c_posy:=0;
  c_tot:=0;

  c_load;
  visa2;


  repeat
    k:=readkey;
    if k=#0 then begin
       k:=readkey;
       case k of
           #72: if c_tot >0 then begin
                   unlight(2,c_posy+3,length(cnf_cfg2^[c_posy].name));
                   if c_posy>1 then deC(c_posy) else c_posy:=c_tot;
                   light(2,c_posy+3,length(cnf_cfg2^[c_posy].name));
                end;
           #80: if c_tot >0 then begin
                   unlight(2,c_posy+3,length(cnf_cfg2^[c_posy].name));
                   if c_posy<c_tot then inc(c_posy) else c_posy:=1;
                   light(2,c_posy+3,length(cnf_cfg2^[c_posy].name));
                end;

           #82: if c_tot<20 then begin { insert }
                  inc(c_tot); c_posy:=c_tot;
                  make_conf(c_tot);
                  visa2;
                end;
       end;

    end else case k of
      #13: begin
             if c_tot>0 then begin
               c_edit(c_posy);

               visa2;
             end;
           end;


    end;
{    i_pipe(60,23,'C_TOT := '+st(c_tot),true);
    i_pipe(60,24,'C_posy:= '+st(c_posy),true); }
  until k=#27;


  if c_tot>0 then c_save;
end;




begin
 init;
 main;

dispose(cnf_cfg2);
  dispose(base_cfg);

  dispose(usr_read); dispose(usr_write);
  dispose(txt);

end.
