{$M $4000,0,50000}
Program Config;

Uses Crt, DOS, Routine, Cursor, FelANSI, FelFX, FelANS, GlobFEL, FelOPEN, FelShne, Savechk;

Procedure MainConfig; Forward;
Procedure PathsConfig; Forward;
Procedure ModemConfig; Forward;
Procedure MainMenu; Forward;
procedure print_space(len : byte); forward;
procedure xywrite(x,y : byte; s : string); forward;
procedure xywriteln(x,y : byte; s : string); forward;
type screentype = array [0..3999] of byte;
var  screen :screentype absolute $B800:0000;
{$I MENU.PAS}

Procedure do_option(count : byte);{modified by spatUla 4/9}
Begin
  Case count Of
    1: mainconfig;
    2: modemconfig;
    3: pathsconfig;
    4: begin
      Shine (25, 1, 55, 18, 15);
      mainmenu;
    end;
    5: begin
      clrScr;
      cursor_on;
      halt;
    end;
  end;
end;

procedure updatemenu ( count : byte); {by spatUla on 4/9/96}
  begin
  textcolor(15);
  if count = 1 then textbackground(1);
  xywrite(31,10,'System Configuration');print_space(64-wherex);
  if count = 1 then textbackground(0);
  if count = 2 then textbackground(1);
  xywrite(31,11,'Modem Configuration');print_space(64-wherex);
  if count = 2 then textbackground(0);
  if count = 3 then textbackground(1);
  xywrite(31,12,'Paths Configuration');print_space(64-wherex);
  if count = 3 then textbackground(0);
  if count = 4 then textbackground(1);
  xywrite(31,13,'Credits');print_space(64-wherex);
  if count = 4 then textbackground(0);
  if count = 5 then textbackground(1);
  xywrite(31,14,'Exit');print_space(64-wherex);
  if count = 5 then textbackground(0);
  end;

procedure mainmenu; {by spatUla on 4/9/96}
  var key : char;
      count : byte;
      stop : boolean;
  begin
  count := 1; stop := false; cursor_off; ReadCfg; grabpallette; Blackout;
  Show_bmback_ans; fadeup; restorepallette;
  gotoxy(27,10);pipeparser('|80[|f01|80] |f0System Configuration',false);
  gotoxy(27,11);pipeparser('|80[|f02|80] |f0Modem Configuration',false);
  gotoxy(27,12);pipeparser('|80[|f03|80] |f0Paths Configuration',false);
  gotoxy(27,13);pipeparser('|80[|f04|80] |f0Credits',false);
  GotoXY(27, 14); pipeparser ('|80[|f05|80] |f0Exit',false);
  repeat
  updatemenu(count);
  key := readkey;
  case key of
    downarrow : begin
      inc(count);
      if count = 6 then count := 1;
    end;
    uparrow : begin
      dec(count);
      if count = 0 then count := 5;
    end;
    #13 : do_option(count);
    #27 : do_option(5);
    '1' : begin updatemenu(1); do_option(1); end;
    '2' : begin updatemenu(2); do_option(2); end;
    '3' : begin updatemenu(3); do_option(3); end;
    '4' : begin updatemenu(4); do_option(4); end;
    '5' : begin updatemenu(5); do_option(5); end;
  end;
  until stop = true;
  end;

Procedure makedir (s: String);{modified by spatUla on 4/9/96}
Var create : Boolean; w1, w2 : Word;
Begin
  (* Have to create every directory in S, in each call several directries
  might have to be created
  If you're gonna create C:\COOL\WAREZ\TODAY
  and you dont have any of the dirs
  MKDIR('C:\COOL\WAREZ\TODAY'); will fail, this procedure will create
  all of the dirs, first COOL, then WAREZ, and finally TODAY..
  *)
  create := True; w2 := Length (s);
  If s [Length (s) ] = '\' Then s [0] := Chr (Length (s) - 1); (* remove '\' *)
  {$I-} MkDir (s); {$I+}
  w1 := IOResult;
  If w1 = 5 Then create := False Else
    If w1 <> 0 Then
    Begin
      w1 := 0;
      Repeat
        Repeat Inc (w1) Until ( (s [w1] = '\') And (s [w1 - 1] <> ':') ) Or (w1 > w2);
        s [0] := Chr (w1 - 1);
        {$I-} MkDir (s); {$I+} If IOResult <> 0 Then; { just to reset ioresult }
      Until w1 >= w2;
    End;
  if create then begin
    gotoxy(17,15);
    print_space(50);
    gotoxy(17,15);
    write('Directory ',s,' was created');
    wait(200);
  end
  else begin
    gotoxy(17,15);
    print_space(50);
    gotoxy(17,15);
    write('Directory ',s,' already exists');
    wait(200);
  end;

End;

Procedure MkDirs; {modified by spatUla on 4/9/96}
Var ans,key : Char;
    n : byte;
    stop : boolean;
Begin
  n := 1; stop := false;
  gotoxy(17,15);
  write('Create Paths ');
  repeat
    if n = 1 then begin
      gotoxy(30,15); pipeparser('|80[|f1Yes|80/|f0No|80]',false)
    end
    else if n = 2 then begin
      gotoxy(30,15); pipeparser('|80[|f0Yes|80/|f1No|80]',false);
    end;
    key := readkey;
    case key of
      rightarrow : begin
        inc(n);
        if n = 3 then n := 1;
      end;
      leftarrow : begin
        dec(n);
        if n = 0 then n := 2;
      end;
      'Y','y' : begin n := 1; stop := true; end;
      'N','n' : begin n := 2; stop := true; end;
    end;
    until (key = #13) or (stop);
    if n = 1 then ans := 'Y'
    else if n = 2 then ans := 'N';
  gotoxy(17,15);
  print_space(30);
  textcolor(15);
  If ans = 'Y'Then Begin
    (*  ******** CREATES ALL DIRECTORIES WITHOUT NO ERROR *)
    makedir (cfg. maindir);
    makedir (cfg. textfiledi);
    makedir (cfg. datadir);
    makedir (cfg. menudir);
    makedir (cfg. tempdir);
  End;
End;

procedure updatemodem ( count : byte); {by spatUla on 4/9/96}
  begin
  textcolor(15);
  if count = 1 then textbackground(1);
  GotoXY (32, 9); Write (cfg. comport); print_space(64-wherex);
  if count = 1 then textbackground(0);
  if count = 2 then textbackground(1);
  xywrite(32,10,cfg.init); print_space(64-wherex);
  if count = 2 then textbackground(0);
  if count = 3 then textbackground(1);
  xywrite(32,11,cfg.onhook); print_space(64-wherex);
  if count = 3 then textbackground(0);
  if count = 4 then textbackground(1);
  GotoXY (32, 12); Write (cfg. baudrate);print_space(64-wherex);
  if count = 4 then textbackground(0);
  if count = 5 then textbackground(1);
  xywrite(32,13,cfg.answer); print_space(64-wherex);
  if count = 5 then textbackground(0);
  if count = 6 then textbackground(1);
  xywrite(32,14,'Exit');print_space(64-wherex);
  if count = 6 then textbackground(0);
  end;

procedure modemconfig; {by spatUla on 4/9/96}
  var key : char;
      count : byte;
      s : string;
      error : word;
      stop : boolean;
  procedure do_config(count : byte);
    begin
     cursor_on;
     updatemodem(count);
      case count of
        1 : begin
          xywrite(17,15,'Comport');
          Str (cfg. comport, s);
          xywrite(20,16,s);
          gotoxy (20,16); write(cfg.comport);
          GotoXY (32, 9);
          GetString (s, 31, '', 8, ' ', 2, True);
          Val (s, cfg. comport, error);
        End;
        2 : begin
          xywrite(17,15,'Init String');
          xywrite(20,16, cfg.init);
          GotoXY (32, 10);
          s := cfg. init;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. init := s;
        End;
        3 : begin
          xywrite(17,15,'Onhook String');
          xywrite(20,16,cfg.onhook);
          GotoXY (32, 11);
          s := cfg. onhook;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. onhook := s;
        End;
        4 : begin
          xywrite(17,15,'Baudrate');
          Str (cfg. baudrate, s);
          xywrite(20,16,s);
          GotoXY (32, 12);
          GetString (s, 31, '', 8, ' ', 1, True);
          Val (s, cfg. baudrate, error);
        End;
        5 : begin
          xywrite(17,15,'Answer String');
          xywrite(20,16,cfg.answer);
          GotoXY (32, 13);
          s := cfg. answer;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. answer := s;
        End;
        6 : stop := true;
      end;
    end;
  begin
  count := 1; stop := false; ReadCfg; grabpallette; Blackout;
  Main_Menu; fadeup; restorepallette;
  GotoXY (8, 9); pipeparser ('|80[|f01|80] |f0Com Port', False);
  GotoXY (8, 10); pipeparser ('|80[|f02|80] |f0Modem Init. String', False);
  GotoXY (8, 11); pipeparser ('|80[|f03|80] |f0On-Hook String', False);
  GotoXY (8, 12); pipeparser ('|80[|f04|80] |f0Baud Rate', False);
  GotoXY (8, 13); pipeparser ('|80[|f05|80] |f0Answer String', False);
  GotoXY (8, 14); pipeparser ('|80[|f06|80] |f0Exit',false);
  gotoxy (8,15);  pipeparser('|f0Option |80: ',false);
  gotoxy (8,16);  pipeparser('|f0Old String|80: ',false);
  repeat
  cursor_off;
  updatemodem(count);
  gotoxy(17,15); print_space(30);
  gotoxy(20,16); print_space(30);
  key := readkey;
  case key of
    downarrow : begin
      inc(count);
      if count = 7 then count := 1;
    end;
    uparrow :   begin
      dec(count);
      if count = 0 then count := 6;
    end;
    #27 : stop := true;
    #13 : do_config(count);
    '1' : begin do_config(1); count := 1; end;
    '2' : begin do_config(2); count := 2; end;
    '3' : begin do_config(3); count := 3; end;
    '4' : begin do_config(4); count := 4; end;
    '5' : begin do_config(5); count := 5; end;
    '6' : begin do_config(6); count := 6; end;
  end;
  until stop = true;
  Checksave(17,15); cursor_off;mainmenu;
  end;
procedure updatemain ( count : byte); {by spatUla on 4/9/96}
  begin
  textcolor(15);
  if count = 1 then textbackground(1);
  xywrite(32,9,cfg.sysopname); print_space(64-wherex);
  if count = 1 then textbackground(0);
  if count = 2 then textbackground(1);
  xywrite(32,10,cfg.boardname); print_space(64-wherex);
  if count = 2 then textbackground(0);
  if count = 3 then textbackground(1);
  xywrite(32,11,cfg.boardtype); print_space(64-wherex);
  if count = 3 then textbackground(0);
  if count = 4 then textbackground(1);
  xywrite(32,12,cfg.newpass); print_space(64-wherex);
  if count = 4 then textbackground(0);
  if count = 5 then textbackground(1);
  xywrite(32,13,cfg.syspass); print_space(64-wherex);
  if count = 5 then textbackground(0);
  if count = 6 then textbackground(1);
  xywrite(32,14,cfg.multinode);print_space(64-wherex);
  if count = 6 then textbackground(0);
  if count = 7 then textbackground(1);
  xywrite(32,15,cfg.matrixtype);print_space(64-wherex);
  if count = 7 then textbackground(0);
  if count = 8 then textbackground(1);
  xywrite(32,16,'Exit');print_space(64-wherex);
  if count = 8 then textbackground(0);
  end;

procedure mainconfig; {by spatUla on 4/9/96}
  var key : char;
      count : byte;
      s : string;
      stop : boolean;
  procedure do_config(count :byte);
    var key : char;
        n : byte;
    begin
      cursor_on;
      updatemain(count);
      case count of
        1 : begin
          xywrite(17,17,'Sysop Name');
          xywrite(20,18,cfg.sysopname);
          GotoXY (32, 9);
          s := cfg. sysopname;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. sysopname := s;
        end;
        2 : begin
          xywrite(17,17,'Board Name');
          xywrite(20,18,cfg.boardname);
          gotoxy(32,10);
          s := cfg. boardname;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. boardname := s;
        end;
        3 : begin
          xywrite(17,17,'Board Type');
          xywrite(20,18,cfg.boardtype);
          gotoxy(32,11); print_space(64-wherex);
          if cfg.boardtype = 'Open' then n := 1
          else n := 2;
          repeat
            if n = 1 then begin
              gotoxy(32,11); pipeparser('|80[|f1Open|80/|f0Closed|80]',false)
            end
            else if n = 2 then begin
            gotoxy(32,11); pipeparser('|80[|f0Open|80/|f1Closed|80]',false);
            end;
            key := readkey;
            case key of
              rightarrow : begin
                inc(n);
                if n = 3 then n := 1;
              end;
              leftarrow : begin
                dec(n);
                if n = 0 then n := 2;
              end;
            end;
          until key = #13;
          if n = 1 then cfg.boardtype := 'Open'
          else if n = 2 then cfg.boardtype := 'Closed';
        end;
        4 : begin
          xywrite(17,17,'New User Password');
          xywrite(20,18,cfg.newpass);
          GotoXY (32, 12);
          s := cfg. newpass;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. newpass := s;
        end;
        5 : begin
          xywrite(17,17,'System Password');
          xywrite(20,18,cfg.syspass);
          gotoxy(32,13);
          s := cfg. syspass;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. syspass := s;
        end;
        6 : begin
          xywrite(17,17,'Multinode');
          xywrite(20,18,cfg.multinode);
          gotoxy(32,14); print_space(64-wherex);
          if cfg.multinode = 'Yes' then n := 1
          else n := 2;
          repeat
            if n = 1 then begin
              gotoxy(32,14); pipeparser('|80[|f1Yes|80/|f0No|80]',false)
            end
            else if n = 2 then begin
            gotoxy(32,14); pipeparser('|80[|f0Yes|80/|f1No|80]',false);
            end;
            key := readkey;
            case key of
              rightarrow : begin
                inc(n);
                if n = 3 then n := 1;
              end;
              leftarrow : begin
                dec(n);
                if n = 0 then n := 2;
              end;
            end;
          until key = #13;
          if n = 1 then cfg.multinode := 'Yes'
          else if n = 2 then cfg.multinode := 'no';
        end;
        7 : begin
          xywrite(17,17,'Matrix Type');
          xywrite(20,18,cfg.matrixtype);
          gotoxy(32,15);
          s := cfg. matrixtype;
          GetString (s, 1, '', 8, ' ', 1, True);
          cfg. matrixtype := s;
        end;
        8 : stop := true;
      end;
    end;
  begin
  count := 1; stop := false; ReadCfg; grabpallette; Blackout;
  Main_Menu; fadeup; restorepallette;
  GotoXY (8, 9); pipeparser ('|80[|f01|80] |f0SysOp Name', False);
  GotoXY (8, 10); pipeparser ('|80[|f02|80] |f0Board Name', False);
  GotoXY (8, 11); pipeparser ('|80[|f03|80] |f0Board Type', False);
  GotoXY (8, 12); pipeparser ('|80[|f04|80] |f0New User Password', False);
  GotoXY (8, 13); pipeparser ('|80[|f05|80] |f0System Password', False);
  GotoXY (8, 14); pipeparser ('|80[|f06|80] |f0Multinode?', False);
  GotoXY (8, 15); pipeparser ('|80[|f07|80] |f0FTP Matrix?', False);
  GotoXY (8, 16); pipeparser ('|80[|f08|80] |f0Exit',false);
  gotoxy (8,17);  pipeparser('|f0Option |80: ',false);
  gotoxy (8,18);  pipeparser('|f0Old String|80: ',false);
  repeat
  cursor_off;
  updatemain(count);
  gotoxy(17,17); print_space(30);
  gotoxy(20,18); print_space(30);
  key := readkey;
  case key of
    downarrow : begin
      inc(count);
      if count = 9 then count := 1;
    end;
    uparrow :   begin
      dec(count);
      if count = 0 then count := 8;
    end;
    #27 : stop := true;
    #13 : do_config(count);
    '1' : begin do_config(1); count := 1; end;
    '2' : begin do_config(2); count := 2; end;
    '3' : begin do_config(3); count := 3; end;
    '4' : begin do_config(4); count := 4; end;
    '5' : begin do_config(5); count := 5; end;
    '6' : begin do_config(6); count := 6; end;
    '7' : begin do_config(7); count := 7; end;
    '8' : begin do_config(8); count := 8; end;
  end;
  until stop = true;
  Checksave(17,17); cursor_off;mainmenu;
  end;
procedure updatepaths ( count : byte); {by spatUla on 4/9/96}
  begin
  textcolor(15);
  if count = 1 then textbackground(1);
  xywrite(32,9,cfg.maindir); print_space(64-wherex);
  if count = 1 then textbackground(0);
  if count = 2 then textbackground(1);
  xywrite(32,10,cfg.textfiledi); print_space(64-wherex);
  if count = 2 then textbackground(0);
  if count = 3 then textbackground(1);
  xywrite(32,11,cfg.datadir); print_space(64-wherex);
  if count = 3 then textbackground(0);
  if count = 4 then textbackground(1);
  xywrite(32,12,cfg.menudir); print_space(64-wherex);
  if count = 4 then textbackground(0);
  if count = 5 then textbackground(1);
  xywrite(32,13,cfg.tempdir); print_space(64-wherex);
  if count = 5 then textbackground(0);
  if count = 6 then textbackground(1);
  xywrite(32,14,'Exit');print_space(64-wherex);
  if count = 6 then textbackground(0);
  end;

procedure pathsconfig; {by spatUla on 4/9/96}
  var key : char;
      count : byte;
      s : string;
      stop : boolean;
  procedure do_config(count:byte);
    begin
      cursor_on;
      updatepaths(count);
      case count of
        1 : begin
          xywrite(17,15,'Felony''s Path');
          xywrite(20,16,cfg.maindir);
          gotoxy(32,9);
          s := cfg. maindir;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. maindir := s;
        end;
        2 : begin
          xywrite(17,15,'Textfile Path');
          xywrite(20,16,cfg.textfiledi);
          gotoxy(32,10);
          s := cfg. textfiledi;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. textfiledi := s;
        end;
        3 : begin
          xywrite(17,15,'Data Path');
          xywrite(20,16,cfg.datadir);
          gotoxy(32,11);
          s := cfg. datadir;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. datadir := s;
        end;
        4 : begin
          xywrite(17,15,'Menu Path');
          xywrite(20,16,cfg.menudir);
          gotoxy(32,12);
          s := cfg. menudir;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. menudir := s;
        end;
        5 : begin
          xywrite(17,15,'Temp Path');
          xywrite(20,16,cfg.tempdir);
          gotoxy(32,13);
          s := cfg. tempdir;
          GetString (s, 31, '', 8, ' ', 1, True);
          cfg. tempdir := s;
          end;
        6 : stop := true;
      end;
    end;


  begin
  count := 1; stop := false; ReadCfg; grabpallette; Blackout;
  Main_Menu; fadeup; restorepallette;
  GotoXY (8, 9); pipeparser ('|80[|f01|80] |f0Felony''s Path', False);
  GotoXY (8, 10); pipeparser ('|80[|f02|80] |f0Textfile Path', False);
  GotoXY (8, 11); pipeparser ('|80[|f03|80] |f0Data Path', False);
  GotoXY (8, 12); pipeparser ('|80[|f04|80] |f0Menu Path', False);
  GotoXY (8, 13); pipeparser ('|80[|f05|80] |f0Temp Path', False);
  GotoXY (8, 14); pipeparser ('|80[|f06|80] |f0Exit',false);
  gotoxy (8,15);  pipeparser('|f0Option |80: ',false);
  gotoxy (8,16);  pipeparser('|f0Old String|80: ',false);
  repeat
  cursor_off;
  updatepaths(count);
  gotoxy(17,15); print_space(30);
  gotoxy(20,16); print_space(30);
  key := readkey;
  case key of
    downarrow : begin
      inc(count);
      if count = 7 then count := 1;
    end;
    uparrow :   begin
      dec(count);
      if count = 0 then count := 6;
    end;
    #27 : stop := true;
    #13 : do_config(count);
    '1' : begin do_config(1); count := 1; end;
    '2' : begin do_config(2); count := 2; end;
    '3' : begin do_config(3); count := 3; end;
    '4' : begin do_config(4); count := 4; end;
    '5' : begin do_config(5); count := 5; end;
    '6' : begin do_config(6); count := 6; end;
  end;
  until stop = true;
  mkdirs;
  If Cfg. MainDir [Length (Cfg. MainDir) ] <> '\' Then Cfg. MainDir := Cfg. MainDir + '\';
  If Cfg. TextFileDi [Length (Cfg. TextFileDi) ] <> '\' Then Cfg. TextFileDi := Cfg. TextFileDi + '\';
  If Cfg. DataDir [Length (Cfg. DataDir) ] <> '\' Then Cfg. DataDir := Cfg. DataDir + '\';
  If Cfg. MenuDir [Length (Cfg. MenuDir) ] <> '\' Then Cfg. MenuDir := Cfg. MenuDir + '\';
  If Cfg. TempDir [Length (Cfg. TempDir) ] <> '\' Then Cfg. TempDir := Cfg. TempDir + '\';
  writecfg;  cursor_off; mainmenu;
  end;
procedure print_space(len : byte); {by spatUla on 4/9/96}
  var x: byte;
  begin
    for x := 1 to len do write(' ');
  end;
procedure xywrite(x,y : byte; s : string); {by spatUla on 4/9/96}
  begin
    gotoxy(x,y);
    write(s);
  end;
procedure xywriteln(x,y : byte; s : string); {by spatUla on 4/9/96}
  begin
    gotoxy(x,y);
    writeln(s);
  end;

Begin
  mainmenu;
End.

