{
 Here is something that you can play with ...

 Shine FX - by Christopher J. C.
 inspired by lotsa product out there that use this kind of FX

 This code is public domain.  Do whatever you want with it.

 A credit line for me would be nice  ;^p
}
Unit FelSHNE;

Interface

Uses crt;

Procedure Init_XTable;
Procedure Shine (sx, sy, ex, ey: Integer; c: Byte);

Implementation

Const MaxRow = 25; MaxColumn = 80;
  
Var Buffer: Array [1..MaxRow] Of Byte;
  XTable: Array [1..MaxRow] Of ShortInt;
  
Procedure Init_XTable;
Var cnt: Byte;
Begin For cnt := 0 To MaxRow - 1 Do XTable [cnt + 1] := - cnt; End;

Procedure Shine (sx, sy, ex, ey: Integer; c: Byte);
Var X, Y: Integer;
  num, cnt: Word;
Begin
  cnt := 0;
  For X := sx To ex + ey - sy Do
  Begin
    For Y := sy To ey Do
      If (XTable [Y - sy + 1] + X > sx - 1) And (XTable [Y - sy + 1] + X < ex + 1) Then
      Begin
        num := (Y - 1) * 160 + (XTable [Y - sy + 1] + (X - 1) ) * 2 + 1;
        Buffer [Y] := mem [$b800: num];                    {save background attr.}
        mem [$b800: num] := c + Buffer [Y] And 240;          {highlight the spot}
      End;
    Asm                                             {retrace}
      mov DX, 3dah;
      @r1: In AL, DX; Test AL, 8; jnz @r1
      @r2: In AL, DX; Test AL, 8; jz @r2
    End;
    For Y := sy To ey Do
      If (XTable [Y - sy + 1] + X > sx - 1) And (XTable [Y - sy + 1] + X < ex + 1) Then
      Begin                                           {restore background attr.}
        mem [$b800: (Y - 1) * 160 + (XTable [Y - sy + 1] + (X - 1) ) * 2 + 1] := Buffer [Y];
      End;
  End;
End;

End.
