unit msgunit;

interface

type
    rtype = record  { needed things }
               age   : string[3]; { in years :) }
               lev   : string[5];
               psw   : string[20];

            end;

    conf_cfg2 = record  { read this in conf.cfg, N times.. }
                  Name : string [40];  { the name of a conf. }
                  Dir  : string [40];   { the sub-dir to above }
                  access : rtype;
                end;

    base_rec2 = record
                  Name     : string[50]; { name of base }
                  filename : string[13]; { filename of msg file }
                  access   : array[1..2] of integer; { who has access here }
                  priv     : boolean; { allow private msgs }
                  anonymus : boolean; { allow anonymus msgs }
                end;

    msg_rec2 = record
                 author,
                 reciever  : string[40];
                 topic     : string[60];
                 rec,priv  : boolean;
                 time,date : string[6];
                 length    : longint; { how many bytes the message is after
                                        this }
               end;

      streng = string[80];   { the lineedit string }

      l_edit = array[1..150] of streng;

VAR tmp_st   : string[20];
    txt      : ^l_edit;      { linedit msg }



function fileexist(filename:string):boolean;
procedure lineedit;

implementation

uses crt,dos;

function FileExist(FileName: String): Boolean;
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;
 Reset(F);
 Close(F);
 {$I+}
 FileExist := (IOResult = 0) and (FileName <> '');
 filemode:=2;
end;


function line_edit(var olen:byte):boolean;
function inp(s2:string):streng;
var k:byte;
    s:streng;
begin
  s:=s2; inp:=''; write(s);
  repeat
    k:=ord(readkey);
    case k of
      8: if length(S)>0 then begin write(#8+#32+#8); delete(s,length(s),1); end;
     13: begin end;
    else if length(s)<70 then begin

      s:=s+chr(k);
      write(chr(k));
    end; end;
  until k=13;
  inp:=s;
end;

var len : word;
    onel: streng;
    a,b : word;
    i   : integer;
    done: boolean;
    save: boolean;

begin
  Writeln('Line Editor v1.0 by ion');
  writeln('quit by writing ### on a new line');
  writeln('----------------------------------------------------------');

  onel:=''; len:=0;
  repeat
    inc(len);
    write(len,':');onel:=inp('');
    writeln;
    if onel<>'###' then txt^[len]:=onel;
  until (len>48) or (onel='###');
  if len<=48 then dec(len);
  done:=false; save:=true;
  repeat
     writeln;
     write('(S)ave, (C)ontinue, (A)bort, (E)dit line, (V)iew msg, (D)elete line: ');
     onel:=inp(''); writeln;
     if length(onel)=1 then case upcase(onel[1]) of
      'S': begin save:=true; done:=true; end;
      'A': begin save:=false; done:=true; end;
      'C': begin
             repeat
                 inc(len);
                 write(len,':');onel:=inp('');
                 writeln;
                 if onel<>'###' then txt^[len]:=onel;
             until (len>48) or (onel='###');
             if len<=48 then dec(len);
            end;
      'E': begin
             write('Line number (1-',len,'): '); onel:=inp('');val(onel,a,i);
             writeln;
             if (i=0) and (a>=1) and (a<=len) then begin
                write(a,':');onel:=inp(txt^[a]); txt^[a]:=onel;
                writeln;
             end;
           end;
      'V': begin
             for a:=1 to len do writeln(a,':',txt^[a]);
           end;
      'D': begin
             write('Line number (1-',len,'): '); onel:=inp('');val(onel,a,i);
             writeln;
             if (i=0) and (a>=1) and (a<=len) then begin
                if a<len then begin
                  for b:=a to len do txt^[b]:=txt^[b+1];
                  dec(len);
                end else begin  txt^[a]:=''; dec(len); end;
                writeln('Line deleted..');
             end;
           end;
    end;

  until done;
  olen:=len;
  line_edit:=save;
end;



procedure lineedit;
var len, a : byte;
begin
 new(txt);

 if line_edit(len) then for a:=1 to len do writeln(a,':',txt^[a]);

 dispose(txt);

end;


begin
end.